October 11th, 2013

404

(no subject)

Как вы думаете, что лучше?
* убивать людей, разрезать их на кусочки и выкидывать в море.
* заниматься прикладной химией в форме приготовления метамфетамина?

Только, чур, без спойлеров. Первое я уже отсмотрел. А вот второе не.
404

А бывают приложения на эрланге

Которые выполняют одновременно три условия:

1) Написаны не в эриксоне
2) Ведут себя не как виндузявый заполнятель налоговых на visual basic
3) Способны внятно в логах написать что им не нравится?

/etc/init.d/rabbitmq-server start
Starting rabbitmq-server: FAILED - check /var/log/rabbitmq/startup_{log, _err}
rabbitmq-server.
cat /var/log/rabbitmq/startup_*
Fri Oct 11 11:27:40 MSK 2013 - rabbitmq failed to start
Fri Oct 11 11:28:37 MSK 2013 - rabbitmq failed to start
Fri Oct 11 11:29:20 MSK 2013 - rabbitmq failed to start

Прихожу к мнению, что это карма такая эрланговая - какать молча в себя и анализы не сдавать.

UPD Не, это не просто халатность, это фимоз головного мозга. Шедевры выделены.

start_rabbitmq () {
status_rabbitmq quiet
if [ $RETVAL = 0 ] ; then
echo RabbitMQ is currently running
else
RETVAL=0
ensure_pid_dir
set +e
RABBITMQ_PID_FILE=$PID_FILE start-stop-daemon --pidfile=$PID_FILE --chuid rabbitmq --exec $DAEMON --background --start
$CONTROL wait $PID_FILE >/dev/null 2>&1
RETVAL=$?
set -e
case "$RETVAL" in
0)
echo SUCCESS
if [ -n "$LOCK_FILE" ] ; then
touch $LOCK_FILE
fi
echo "`date` - rabbitmq successfully started" >> ${INIT_LOG_DIR}/startup_log
# only emit the event on boot
[ -n "$UPSTART_JOB" ] && initctl emit --no-wait rabbitmq-server-running || true
;;
*)
remove_pid
echo FAILED - check ${INIT_LOG_DIR}/startup_\{log, _err\}
echo "`date` - rabbitmq failed to start" >> ${INIT_LOG_DIR}/startup_err
RETVAL=1
;;
esac
fi
}

Для понимания степени пиздеца - это происходит из postinst'а пакета, который пытается стартануть непонятно что непонятно зачем, потом это дохнет непонятно почему и молча, а dpkg честно говорит, что postinst failed и вообще

dpkg: error processing rabbitmq-server (--configure):
subprocess installed post-installation script returned error exit status 1
Errors were encountered while processing:
rabbitmq-server

Можете считать меня предвзятым, но настолько тупое поведение я встречал в своей жизни всего несколько раз.
Это:
* банк-клиент Авангарда 2007 года версии. Visual Basic, вроде.
* Программа ПЕРФС (или как-то так). То ли дельфи, то ли Visual Fox Pro.
* некая самописная приблуда сотворённая одним чудо-программистом на эрланге в одной из контор, где я работал
* Некая несамописная софтинка, который этот чудо-программист на эрланге пиарил
* rabbitmq-server

Так сказать, к вопросу о тенденциях.

PS To anyone who drifted here by google.


Problem is very classic for erlang-retar... related software.

/usr/lib/rabbitmq/bin/rabbitmq-server
Activating RabbitMQ plugins ...
0 plugins activated:

ERROR: epmd error for host "test": address (unable to establish tcp connection)

(still thinking how to make that stupid thing to start own beam.smp/epmd copy)
404

erlang...

И оно началось...

{error_logger,{{2013,10,11},{12,1,5}},"Protocol: ~p: register error: ~p~n",["inet_tcp",{{badmatch,{error,no_reg_reply_from_epmd}},[{inet_tcp_dist,listen,1},{net_kernel,start_protos,4},{net_kernel,start_protos,3},{net_kernel,init_node,2},{net_kernel,init,1},{gen_server,init_it,6},{proc_lib,init_p_do_apply,3}]}]}
{error_logger,{{2013,10,11},{12,1,5}},crash_report,[[{initial_call,{net_kernel,init,['Argument__1']}},{pid,<0.19.0>},{registered_name,[]},{error_info,{exit,{error,badarg},[{gen_server,init_it,6},{proc_lib,init_p_do_apply,3}]}},{ancestors,[net_sup,kernel_sup,<0.9.0>]},{messages,[]},{links,[#Port<0.87>,<0.16.0>]},{dictionary,[{longnames,false}]},{trap_exit,true},{status,running},{heap_size,377},{stack_size,24},{reductions,507}],[]]}
{error_logger,{{2013,10,11},{12,1,5}},supervisor_report,[{supervisor,{local,net_sup}},{errorContext,start_error},{reason,{'EXIT',nodistribution}},{offender,[{pid,undefined},{name,net_kernel},{mfargs,{net_kernel,start_link,[[rabbitmqprelaunch19205,shortnames]]}},{restart_type,permanent},{shutdown,2000},{child_type,worker}]}]}
{error_logger,{{2013,10,11},{12,1,5}},supervisor_report,[{supervisor,{local,kernel_sup}},{errorContext,start_error},{reason,shutdown},{offender,[{pid,undefined},{name,net_sup},{mfargs,{erl_distribution,start_link,[]}},{restart_type,permanent},{shutdown,infinity},{child_type,supervisor}]}]}
{error_logger,{{2013,10,11},{12,1,5}},std_info,[{application,kernel},{exited,{shutdown,{kernel,start,[normal,[]]}}},{type,permanent}]}
{"Kernel pid terminated",application_controller,"{application_start_failure,kernel,{shutdown,{kernel,start,[normal,[]]}}}"}
Kernel pid terminated (application_controller) ({application_start_failure,kernel,{shutdown,{kernel,start,[normal,[]]}}})


Заметим, господа, речь идёт не про настройку этого говна, а про банальный apt-get install, из которого только на эрланге смогли сделать такое говно.

Теоретически, наверное, он хотел сказать Protocol register error, no reg reply from epmd, но какого хрена эти люди не пишут в машинных кодах? Было бы проще и понятнее и им, и окружающим.